package main

import (
	"strconv"

	sdk "github.com/soracom/orbit-sdk-tinygo"
)

// application entry point, but the orbit runtime never executes this.
func main() {
}

//export uplink
func uplink() sdk.ErrorCode {
	inputBuffer, err := sdk.GetInputBuffer()
	if err != nil {
		sdk.Log(err.Error())
		return -1
	}
	sdk.Log("Input Buffer: " + string(inputBuffer) + "\n")

	tagValue, err := sdk.GetTagValue("name")
	if err != nil {
		sdk.Log(err.Error())
		return -1
	}
	sdk.Log("Name: " + string(tagValue) + "\n")

	sourceValue, err := sdk.GetSourceValue("resourceType")
	if err != nil {
		sdk.Log(err.Error())
		return -1
	}
	sdk.Log("Resource type: " + string(sourceValue) + "\n")

	timestamp := sdk.GetTimestamp()
	if err != nil {
		sdk.Log(err.Error())
		return -1
	}
	sdk.Log("Timestamp: " + strconv.FormatInt(timestamp, 10) + "\n")

	sdk.SetOutputJSON("{\"message\": \"Hello from Orbit with TinyGo\"}")

	return sdk.ErrorCode(0)
}
